/********************************************************************************
 *                        Downatool2
 *
 *
 *
 * Copyright (C) 2009  Felix Leder & Tillmann Werner
 * based on preliminary work from MHL, B. Enright
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * 
 * 
 *             contact {leder,werner}@cs.uni-bonn.de
 *
 *******************************************************************************/


#include <windows.h>
#include <stdio.h>
#include <math.h>
#include "downatool.h"


#  define C_CON1 0x2682D10B7
#  define C_CON2 0x19254D38000
#  define C_CON3 0x0F1E34A09
#  define C_CON_RAND 0x4F3D859E
#  define C_CON_DBL 0.946270391
const char* C_DOMAINLIST[] = {".ac", ".ae", ".ag", ".am", ".as", ".at", ".be", ".bo", ".bz", ".ca", ".cd", ".ch", ".cl", ".cn", ".co.cr", ".co.id", ".co.il", ".co.ke", ".co.kr", ".co.nz", ".co.ug", ".co.uk", ".co.vi", ".co.za", ".com.ag", ".com.ai", ".com.ar", ".com.bo", ".com.br", ".com.bs", ".com.co", ".com.do", ".com.fj", ".com.gh", ".com.gl", ".com.gt", ".com.hn", ".com.jm", ".com.ki", ".com.lc", ".com.mt", ".com.mx", ".com.ng", ".com.ni", ".com.pa", ".com.pe", ".com.pr", ".com.pt", ".com.py", ".com.sv", ".com.tr", ".com.tt", ".com.tw", ".com.ua", ".com.uy", ".com.ve", ".cx", ".cz", ".dj", ".dk", ".dm", ".ec", ".es", ".fm", ".fr", ".gd", ".gr", ".gs", ".gy", ".hk", ".hn", ".ht", ".hu", ".ie", ".im", ".in", ".ir", ".is", ".kn", ".kz", ".la", ".lc", ".li", ".lu", ".lv", ".ly", ".md", ".me", ".mn", ".ms", ".mu", ".mw", ".my", ".nf", ".nl", ".no", ".pe", ".pk", ".pl", ".ps", ".ro", ".ru", ".sc", ".sg", ".sh", ".sk", ".su", ".tc", ".tj", ".tl", ".tn", ".to", ".tw", ".us", ".vc", ".vn"};
#  define C_LIST_SELECT_OP %0x74
#  define C_DOMAINMAX 50000


#  define B_CON1 0x352C94565
#  define B_CON2 0x058028E44000
#  define B_CON3 0x0A3596526
#  define B_CON_RAND 0x53125624
#  define B_CON_DBL 6.26454564e-1
const char* B_DOMAINLIST[] = {".cc", ".cn", ".ws", ".com", ".net", ".org", ".info", ".biz"};
#  define B_LIST_SELECT_OP &7
#  define B_DOMAINMAX 250


#  define A_CON1 0x463DA5676
#  define A_CON2 0x058028E44000
#  define A_CON3 0x0B46A7637
#  define A_CON_RAND 0x64236735
#  define A_CON_DBL 0.737565675
const char* A_DOMAINLIST[] = {".com", ".net", ".org", ".info", ".biz"};
#  define A_LIST_SELECT_OP %5
#  define A_DOMAINMAX 250




/* global vars */
/* this is ugly but works for now :/ */
DWORD64 CON1;
DWORD64 CON2;
DWORD64 CON3;
DWORD64 CON_RAND;
DWORD   DOMAINMAX;



DWORD64 mykey = 0;
double dbl;
const char **tld_list;


int verbose = 0;


int Rand()
{
	double   res1;
	double   d2;
	double   s_val;
	DWORD64  prod;

	d2 = mykey;

	s_val = sin(d2);
	
	prod = mykey * CON_RAND;
	res1 = (( ((prod + s_val) * d2) + dbl ) * d2 );
	res1+= log(d2);
	  	
	*(double*)&mykey = res1;	

	printf("mykey %x%08x\n", (int) (mykey>>32), (int) mykey & 0xffffffff);

	return mykey;
}




void print_domains (char * datestr, int variant)
{
	SYSTEMTIME time;
	FILETIME filetime;
	char domain[32]; 

	memset(&time, 0, sizeof(SYSTEMTIME));
	memset(&filetime, 0, sizeof(FILETIME));

	if (datestr == NULL)
	{
		GetSystemTime(&time);
		time.wDayOfWeek = 0;
		time.wHour = 0;
		time.wMilliseconds = 0;
		time.wMinute = 0;
		time.wSecond = 0;
	}
	else 
	{
	  sscanf(datestr, "%4d%2d%2d", 
		 (unsigned int*) &time.wYear, 
		 (unsigned int*) &time.wMonth, 
		 (unsigned int*)&time.wDay);
	}

	printf("Generating domains for %d-%02d-%02d\n\n", time.wYear, time.wMonth, time.wDay);

	SystemTimeToFileTime(&time, &filetime);

	
	switch(variant)
	  {
	  case CONFICKER_VARIANT_A:
	    CON1 = A_CON1;
	    CON2 = A_CON2;
	    CON3 = A_CON3;
	    CON_RAND = A_CON_RAND;
	    dbl  = A_CON_DBL;
	    tld_list = A_DOMAINLIST;
	    DOMAINMAX = A_DOMAINMAX;
	    break;
	  case CONFICKER_VARIANT_B:
	    CON1 = B_CON1;
	    CON2 = B_CON2;
	    CON3 = B_CON3;
	    CON_RAND = B_CON_RAND;
	    dbl  = B_CON_DBL;
	    tld_list = B_DOMAINLIST;
	    DOMAINMAX = B_DOMAINMAX;
	    break;
	  case CONFICKER_VARIANT_C:
	    CON1 = C_CON1;
	    CON2 = C_CON2;
	    CON3 = C_CON3;
	    CON_RAND = C_CON_RAND;
	    dbl  = C_CON_DBL;
	    tld_list = C_DOMAINLIST;
	    DOMAINMAX = C_DOMAINMAX;
	    break;
	  };



	mykey = (*(DWORD64*)&filetime) * CON1  / CON2 + CON3;


	ExitProcess(2);

	int max = DOMAINMAX;

	while(max--)
	{
	  int len;
	  
	  if (variant == CONFICKER_VARIANT_C)
	    len = (abs(Rand()) % 6) + 4;	  
	  else
	    len = (Rand() % 4) + 8;

	  int i = 0;
	  int start = 0;		

	  memset(domain, 0, sizeof(domain));
			
	  while(i < len)
	    {
	      start = (labs(Rand()) % 26) + 97;
	      domain[i++] = (unsigned char) start;
	      //printf("key %llx\n", mykey);
	    }
	
	  domain[i] = '\0';
	  if (variant == CONFICKER_VARIANT_C) {
	    long val = abs(Rand());
	    val = val % 0x74;		
	    strcat(domain, tld_list[val]);
	  }
	  else if (variant == CONFICKER_VARIANT_B){
	    DWORD val = Rand();
	    val = val & 7;
	    strcat(domain, tld_list[val]);
	  }
	  else {
	    DWORD val = Rand();
	    val = val % 5;
	    strcat(domain, tld_list[val]);
	  }
	  printf("%s\n", domain);
	}		
	fflush(stdout);
	ExitProcess(0);
}
