/********************************************************************************
 *                        Downatool2
 *
 *
 *
 * Copyright (C) 2009  Felix Leder & Tillmann Werner
 * based on preliminary work from MHL, B. Enright
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * 
 * 
 *             contact {leder,werner}@cs.uni-bonn.de
 *
 *******************************************************************************/


#include "downatool.h"

void print_usage(char * progname)
{
	printf("Usage:\n"
	       "%s [YYYYMMDD]  [-a, -b, -c]\n\n"
	       "print Conficker/Downadup domains - default: today\n"
	       "for variants .A, .B, or .C - default: .A\n",
	       progname);

	ExitProcess(1);
}

int main (int argc, char **argv)
{
  int variant = CONFICKER_VARIANT_A;
  int i;
  char* date = NULL;
  char* arg;

  printf("\n/*------------------------------------------------------------*/\n");
  printf("/* Downadup/Conficker Domain Name Generation                  */\n");
  printf("/*                                                            */\n");
  printf("/* by Felix Leder, Tillmann Werner @ University of Bonn 2009  */\n");
  printf("/* {leder,werner}@cs.uni-bonn.de                              */\n");
  printf("/*                                                            */\n");
  printf("/*------------------------------------------------------------*/\n");
  
  
  for (i=1; i< argc; ++i) {
    arg = argv[i];
    
    //Conficker type
    if (strlen(arg) == 2) {
      if (!strcmpi(arg, "-c")) variant = CONFICKER_VARIANT_C;
      else if (!strcmpi(arg, "-b")) variant = CONFICKER_VARIANT_B;
      else if (!strcmpi(arg, "-a")) variant = CONFICKER_VARIANT_A;
      else print_usage(argv[0]);
    }
    //Date
    else if (strlen(arg) == 8) date = arg;
    else print_usage(argv[0]);
  }

  printf("Generating domains for Conficker.");
  switch (variant)
    {
    case CONFICKER_VARIANT_A: puts("A");
      break;
    case CONFICKER_VARIANT_B: puts("B");
      break;
    case CONFICKER_VARIANT_C: puts("C");
      break;
    }
  
  print_domains(date, variant);

  return 0;
}
